{
    "$graph": [
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "registry.gitlab.com/uc-cdis/genomel-primary-analysis/harmonization_with_bwa:1.0"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ResourceRequirement"
                },
                {
                    "class": "ShellCommandRequirement"
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "type": "string",
                    "default": "tempfq",
                    "id": "#bam_to_fastq.cwl/T"
                },
                {
                    "type": "int",
                    "default": 1,
                    "id": "#bam_to_fastq.cwl/collate"
                },
                {
                    "type": "File",
                    "id": "#bam_to_fastq.cwl/filename"
                },
                {
                    "type": "int",
                    "default": 1,
                    "id": "#bam_to_fastq.cwl/gz"
                },
                {
                    "type": "string",
                    "default": "bam",
                    "id": "#bam_to_fastq.cwl/inputformat"
                },
                {
                    "type": "string",
                    "id": "#bam_to_fastq.cwl/job_uuid"
                },
                {
                    "type": "int",
                    "default": 5,
                    "id": "#bam_to_fastq.cwl/level"
                },
                {
                    "type": "string",
                    "default": ".",
                    "id": "#bam_to_fastq.cwl/outputdir"
                },
                {
                    "type": "int",
                    "default": 1,
                    "id": "#bam_to_fastq.cwl/outputperreadgroup"
                },
                {
                    "type": "int",
                    "default": 1,
                    "id": "#bam_to_fastq.cwl/outputperreadgrouprgsm"
                },
                {
                    "type": "string",
                    "default": "_1.fq.gz",
                    "id": "#bam_to_fastq.cwl/outputperreadgroupsuffixF"
                },
                {
                    "type": "string",
                    "default": "_2.fq.gz",
                    "id": "#bam_to_fastq.cwl/outputperreadgroupsuffixF2"
                },
                {
                    "type": "string",
                    "default": "_o1.fq.gz",
                    "id": "#bam_to_fastq.cwl/outputperreadgroupsuffixO"
                },
                {
                    "type": "string",
                    "default": "_o2.fq.gz",
                    "id": "#bam_to_fastq.cwl/outputperreadgroupsuffixO2"
                },
                {
                    "type": "string",
                    "default": "_s.fq.gz",
                    "id": "#bam_to_fastq.cwl/outputperreadgroupsuffixS"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "id": "#bam_to_fastq.cwl/readgroup_lines"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "id": "#bam_to_fastq.cwl/readgroup_names"
                },
                {
                    "type": "int",
                    "default": 1,
                    "id": "#bam_to_fastq.cwl/tryoq"
                }
            ],
            "baseCommand": [],
            "arguments": [
                {
                    "position": 0,
                    "shellQuote": false,
                    "valueFrom": "/usr/bin/time -f \"{\\\\\"real_time\\\\\": \\\\\"%E\\\\\", \\\\\"user_time\\\\\": %U, \\\\\"system_time\\\\\": %S, \\\\\"wall_clock\\\\\": %e, \\\\\"maximum_resident_set_size\\\\\": %M, \\\\\"average_total_mem\\\\\": %K, \\\\\"percent_of_cpu\\\\\": \\\\\"%P\\\\\"}\" -o $(inputs.job_uuid + '.SamtoolsViewBam_BammToFastq' + '.time.json') samtools view -@ 8 -Shb $(inputs.filename.path) | /opt/biobambam2/2.0.87-release-20180301132713/x86_64-etch-linux-gnu/bin/bamtofastq collate=$(inputs.collate) filename=/dev/stdin gz=$(inputs.gz) inputformat=$(inputs.inputformat) level=$(inputs.level) outputdir=$(inputs.outputdir) outputperreadgroup=$(inputs.outputperreadgroup) outputperreadgrouprgsm=$(inputs.outputperreadgrouprgsm) outputperreadgroupsuffixF=$(inputs.outputperreadgroupsuffixF) outputperreadgroupsuffixF2=$(inputs.outputperreadgroupsuffixF2) outputperreadgroupsuffixO=$(inputs.outputperreadgroupsuffixO) outputperreadgroupsuffixO2=$(inputs.outputperreadgroupsuffixO2) outputperreadgroupsuffixS=$(inputs.outputperreadgroupsuffixS) tryoq=$(inputs.tryoq) T=$(inputs.T)"
                }
            ],
            "id": "#bam_to_fastq.cwl",
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*_1.fq.gz",
                        "outputEval": "${ return self.sort(function(a,b) { return a.location > b.location ? 1 : (a.location < b.location ? -1 : 0) }) }\n"
                    },
                    "id": "#bam_to_fastq.cwl/output_fastq1"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*_2.fq.gz",
                        "outputEval": "${ return self.sort(function(a,b) { return a.location > b.location ? 1 : (a.location < b.location ? -1 : 0) }) }\n"
                    },
                    "id": "#bam_to_fastq.cwl/output_fastq2"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "outputBinding": {
                        "outputEval": "${ return inputs.readgroup_lines.sort(function(a,b) { return a > b ? 1 : (a < b ? -1 : 0) }) }\n"
                    },
                    "id": "#bam_to_fastq.cwl/output_readgroup_lines"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "outputBinding": {
                        "outputEval": "${ return inputs.readgroup_names.sort(function(a,b) { return a > b ? 1 : (a < b ? -1 : 0) }) }\n"
                    },
                    "id": "#bam_to_fastq.cwl/output_readgroup_names"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.job_uuid + '.SamtoolsViewBam_BammToFastq' + '.time.json')"
                    },
                    "id": "#bam_to_fastq.cwl/time_metrics"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "registry.gitlab.com/uc-cdis/genomel-primary-analysis/harmonization_with_bwa:1.0"
                },
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "MultipleInputFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "id": "#get_readgroup_name.cwl/bam"
                }
            ],
            "stdout": "readgroups_header",
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "outputBinding": {
                        "glob": "readgroups_header",
                        "loadContents": true,
                        "outputEval": "${\n  var rg_line = [];\n  for (var i = 0; i < self[0].contents.trim().split('\\n').length; i++ ){\n    rg_line.push(self[0].contents.trim().split('\\n')[i])\n  };\n  return rg_line\n}\n"
                    },
                    "id": "#get_readgroup_name.cwl/readgroup_lines"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "outputBinding": {
                        "glob": "readgroups_header",
                        "loadContents": true,
                        "outputEval": "${\n  var rg_name = [];\n  for (var i = 0; i < self[0].contents.trim().split('\\n').length; i++ ){\n    rg_name.push(self[0].contents.trim().split('\\n')[i].split('\\t')[1].replace('ID:', '').replace(/\\#/g, '%2'))\n  };\n  return rg_name\n}\n"
                    },
                    "id": "#get_readgroup_name.cwl/readgroup_names"
                }
            ],
            "baseCommand": [],
            "arguments": [
                {
                    "valueFrom": "samtools view -H $(inputs.bam.path) | grep \"^@RG\"",
                    "shellQuote": false
                }
            ],
            "id": "#get_readgroup_name.cwl"
        },
        {
            "class": "Workflow",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "StepInputExpressionRequirement"
                },
                {
                    "class": "MultipleInputFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "id": "#main/input_bam"
                },
                {
                    "type": "string",
                    "id": "#main/job_uuid"
                }
            ],
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#main/bam_to_fastq/output_fastq1",
                    "id": "#main/output_fastq1"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#main/bam_to_fastq/output_fastq2",
                    "id": "#main/output_fastq2"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "outputSource": "#main/bam_to_fastq/output_readgroup_lines",
                    "id": "#main/output_readgroup_lines"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "outputSource": "#main/bam_to_fastq/output_readgroup_names",
                    "id": "#main/output_readgroup_names"
                },
                {
                    "type": "File",
                    "outputSource": "#main/bam_to_fastq/time_metrics",
                    "id": "#main/time_metrics_from_bam_to_fastq"
                }
            ],
            "steps": [
                {
                    "run": "#bam_to_fastq.cwl",
                    "in": [
                        {
                            "source": "#main/input_bam",
                            "id": "#main/bam_to_fastq/filename"
                        },
                        {
                            "source": "#main/job_uuid",
                            "id": "#main/bam_to_fastq/job_uuid"
                        },
                        {
                            "source": "#main/get_readgroup_info/readgroup_lines",
                            "id": "#main/bam_to_fastq/readgroup_lines"
                        },
                        {
                            "source": "#main/get_readgroup_info/readgroup_names",
                            "id": "#main/bam_to_fastq/readgroup_names"
                        }
                    ],
                    "out": [
                        "#main/bam_to_fastq/output_readgroup_lines",
                        "#main/bam_to_fastq/output_readgroup_names",
                        "#main/bam_to_fastq/output_fastq1",
                        "#main/bam_to_fastq/output_fastq2",
                        "#main/bam_to_fastq/time_metrics"
                    ],
                    "id": "#main/bam_to_fastq"
                },
                {
                    "run": "#get_readgroup_name.cwl",
                    "in": [
                        {
                            "source": "#main/input_bam",
                            "id": "#main/get_readgroup_info/bam"
                        }
                    ],
                    "out": [
                        "#main/get_readgroup_info/readgroup_lines",
                        "#main/get_readgroup_info/readgroup_names"
                    ],
                    "id": "#main/get_readgroup_info"
                }
            ],
            "id": "#main"
        }
    ],
    "cwlVersion": "v1.0"
}
